package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PelatihanPaketService;
import com.jasamedika.medifirst2000.vo.PelatihanPaketVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/pelatihan-paket")
public class PelatihanPaketController extends LocaleController<PelatihanPaketVO> {

	private static final Logger LOGGER = getLogger(PelatihanPaketController.class);

	@Autowired
	private PelatihanPaketService pelatihanPaketService;

	@RequestMapping(value = "/save-pelatihan-paket/", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> savePelatihanPaket(@Valid @RequestBody PelatihanPaketVO vo,
			HttpServletRequest request, HttpServletResponse response) {
		try {
			Map<String, Object> result = pelatihanPaketService.savePelatihanPaket(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when savePelatihanPaket", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when savePelatihanPaket", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/daftar-komponen")
	@ResponseBody
	public Map<String, Object> daftarKomponen() {
		return pelatihanPaketService.daftarKomponen();
	}

	@RequestMapping(value = "/list-pelatihan-paket")
	@ResponseBody
	public Map<String, Object> listBarangBmhp(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "10000000") Integer limit,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@RequestParam(value = "tanggalAwal", required = false) String tanggalAwal,
			@RequestParam(value = "tanggalAhir", required = false) String tanggalAhir) {
		return pelatihanPaketService.listPelatihanPaket(page, limit, sort, dir, tanggalAwal, tanggalAhir);
	}

	@RequestMapping(value = "/detail-pelatihan-paket", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> detailPelatihanPaket(
			@RequestParam(value = "strukPlanningId") String strukPlanningId,
			@RequestParam(value = "produkId") Integer produkId) {
        return pelatihanPaketService.detailPelatihanPaket(strukPlanningId, produkId);
	}

}
